#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define yyparse lease_yyparse
#define yylex lease_yylex
#define yyerror lease_yyerror
#define yychar lease_yychar
#define yyval lease_yyval
#define yylval lease_yylval
#define yydebug lease_yydebug
#define yynerrs lease_yynerrs
#define yyerrflag lease_yyerrflag
#define yyss lease_yyss
#define yyssp lease_yyssp
#define yyvs lease_yyvs
#define yyvsp lease_yyvsp
#define yylhs lease_yylhs
#define yylen lease_yylen
#define yydefred lease_yydefred
#define yydgoto lease_yydgoto
#define yysindex lease_yysindex
#define yyrindex lease_yyrindex
#define yygindex lease_yygindex
#define yytable lease_yytable
#define yycheck lease_yycheck
#define yyname lease_yyname
#define yyrule lease_yyrule
#define yysslim lease_yysslim
#define yystacksize lease_yystacksize
#define YYPREFIX "lease_yy"
#line 2 "leasegrammer.y"
/***************************************************************************
                          leasegrammer.y  -  description
                             -------------------
    copyright            : (C) 2002 by Willy De la Court
    email                : willy.delacourt@pandora.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2 as     *
 *   published by the Free Software Foundation                             *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <string.h>
#include <qstringlist.h>
#include "confparser.h"
#include "leaseparser.h"

#define YYSTYPE char *
#define YYDEBUG 0
#define YYMAXDEPTH 0
#define YYPARSE_PARAM lease_parser

extern int yylex(void);
extern int lease_lineno;

dataItem *lease_data = 0L;
leaseItem *currentLease = 0L;
LeaseParser *lease_p = 0;

void yyerror(const char *str)
{
	if( lease_p )
		lease_p->addSyntaxError( lease_lineno );
	fprintf(stderr,"error: %s in line %d\n", str, lease_lineno);
}

void lease_init( void *lease_parser )
{
	lease_p = static_cast<LeaseParser *>(lease_parser);
}

/*void lease_add_option(const char *txt, const char *val, void *lease_parser)
{
	lease_data = new dataItem(txt, val);
	if( currentLease )
		currentLease->addOption(lease_data);
	printf("*%s %s*\n", txt, val);
}*/

#define INIT()						lease_init(lease_parser);
#define ADD_LEASE(ip)				currentLease = new leaseItem(ip); \
									LeaseParser *p = static_cast<LeaseParser *>(lease_parser); \
									p->addLease(currentLease); \
									lease_data = currentLease;

#define ADD_STARTS(val1, val2, val3)	if( currentLease ) { \
											currentLease->itemStartsDay = val1; \
											currentLease->itemStartsDate = val2; \
											currentLease->itemStartsTime = val3; \
										}

#define ADD_ENDS(val1, val2, val3)		if( currentLease ) { \
											currentLease->itemEndsDay = val1; \
											currentLease->itemEndsDate = val2; \
											currentLease->itemEndsTime = val3; \
										}

#define ADD_MAC(val)					if( currentLease ) { currentLease->itemMAC = val; }
#define ADD_UID(val)					if( currentLease ) { currentLease->itemUid = val; }
#define ADD_CLIENTHOSTNAME(val)			if( currentLease ) { currentLease->itemClientHostname = val; }
#define ADD_HOSTNAME(val)				if( currentLease ) { currentLease->itemHostname = val; }
#define ADD_ABANDONED()					if( currentLease ) { currentLease->itemAbandoned = true; }
#define SET_COMMENT(val)				if(lease_data) \
											lease_data->setComment(val); \
										/*printf("comment %s\n", val);*/

#line 125 "leasegrammer.tab.c"
#define YYERRCODE 256
#define LEASE 257
#define STARTS 258
#define ENDS 259
#define UID 260
#define HARDWARE 261
#define ETHERNET 262
#define CLIENTHOSTNAME 263
#define HOSTNAME 264
#define ABANDONED 265
#define QUOTE 266
#define IP 267
#define NUMBER 268
#define MAC 269
#define UIDCODE 270
#define DOMAIN 271
#define COMMENT 272
#define WORD 273
#define DATE 274
#define TIME 275
const short lease_yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    5,    2,    6,    6,    6,
    6,    7,    7,    7,    7,    7,    7,    7,    4,    4,
    3,
};
const short lease_yylen[] = {                                         2,
    0,    2,    1,    1,    2,    0,    8,    0,    3,    2,
    2,    5,    5,    3,    5,    5,    4,    2,    0,    2,
    1,
};
const short lease_yydefred[] = {                                      1,
    0,    0,    0,   21,    2,    3,    4,    5,    6,   19,
    0,   19,   20,    0,    0,    0,   11,   10,    7,    0,
    0,    0,    0,    0,    0,    0,   19,    0,    0,    0,
    0,    0,    0,   18,    0,    0,    0,   14,    0,    0,
    0,    0,    0,   17,    0,    0,   12,   13,   15,   16,
};
const short lease_yydgoto[] = {                                       1,
    5,    6,   13,   11,   10,   16,   27,
};
const short lease_yysindex[] = {                                      0,
 -253, -119, -259,    0,    0,    0,    0,    0,    0,    0,
 -123,    0,    0, -251,  -57, -124,    0,    0,    0, -258,
 -257, -261, -249, -252, -250,  -44,    0, -256, -248,  -42,
 -246, -245, -244,    0, -247, -243, -242,    0,  -35, -239,
 -236,  -28,  -25,    0,  -24,  -23,    0,    0,    0,    0,
};
const short lease_yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -113,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -105,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
const short lease_yygindex[] = {                                      0,
    0,    0,   36,   -5,    0,    0,    0,
};
#define YYTABLESIZE 160
const short lease_yytable[] = {                                      12,
   19,   18,    2,    3,   15,    8,   14,    9,   30,   28,
   29,    8,   31,   32,   34,   33,   38,   36,    4,    9,
    4,   35,   39,   44,    4,   37,   45,   40,   41,   46,
   47,   42,   43,   48,   49,   50,    7,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   17,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   20,   21,   22,   23,    0,   24,   25,
   26,    0,    0,    0,    8,    8,    8,    8,    4,    8,
    8,    8,    9,    9,    9,    9,    0,    9,    9,    9,
};
const short lease_yycheck[] = {                                     123,
  125,   59,  256,  257,  256,  125,   12,  267,  270,  268,
  268,  125,  262,  266,   59,  266,   59,  274,  272,  125,
  272,   27,  269,   59,  272,  274,  266,  273,  273,  266,
   59,  275,  275,   59,   59,   59,    1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  258,  259,  260,  261,   -1,  263,  264,
  265,   -1,   -1,   -1,  258,  259,  260,  261,  272,  263,
  264,  265,  258,  259,  260,  261,   -1,  263,  264,  265,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 275
#if YYDEBUG
const char * const lease_yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,"'-'","'.'",0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"LEASE",
"STARTS","ENDS","UID","HARDWARE","ETHERNET","CLIENTHOSTNAME","HOSTNAME",
"ABANDONED","QUOTE","IP","NUMBER","MAC","UIDCODE","DOMAIN","COMMENT","WORD",
"DATE","TIME",
};
const char * const lease_yyrule[] = {
"$accept : file",
"file :",
"file : file all",
"all : leases",
"all : comment",
"all : error '}'",
"$$1 :",
"leases : LEASE IP $$1 comments '{' comments options '}'",
"options :",
"options : options option comments",
"options : error ';'",
"options : error '}'",
"option : STARTS NUMBER DATE TIME ';'",
"option : ENDS NUMBER DATE TIME ';'",
"option : UID UIDCODE ';'",
"option : CLIENTHOSTNAME QUOTE WORD QUOTE ';'",
"option : HOSTNAME QUOTE WORD QUOTE ';'",
"option : HARDWARE ETHERNET MAC ';'",
"option : ABANDONED ';'",
"comments :",
"comments : comments comment",
"comment : COMMENT",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 113 "leasegrammer.y"
{ INIT(); }
break;
case 5:
#line 120 "leasegrammer.y"
{ yyclearin; yyerrok; }
break;
case 6:
#line 124 "leasegrammer.y"
{ ADD_LEASE(yyvsp[0]); }
break;
case 10:
#line 133 "leasegrammer.y"
{ yyclearin; yyerrok; }
break;
case 11:
#line 134 "leasegrammer.y"
{ yyclearin; yyerrok; }
break;
case 12:
#line 138 "leasegrammer.y"
{ ADD_STARTS(yyvsp[-3], yyvsp[-2], yyvsp[-1]); }
break;
case 13:
#line 139 "leasegrammer.y"
{ ADD_ENDS(yyvsp[-3], yyvsp[-2], yyvsp[-1]); }
break;
case 14:
#line 140 "leasegrammer.y"
{ ADD_UID(yyvsp[-1]); }
break;
case 15:
#line 141 "leasegrammer.y"
{ ADD_CLIENTHOSTNAME(yyvsp[-2]); }
break;
case 16:
#line 142 "leasegrammer.y"
{ ADD_HOSTNAME(yyvsp[-2]); }
break;
case 17:
#line 143 "leasegrammer.y"
{ ADD_MAC(yyvsp[-1]); }
break;
case 18:
#line 144 "leasegrammer.y"
{ ADD_ABANDONED(); }
break;
case 21:
#line 153 "leasegrammer.y"
{ SET_COMMENT(yyvsp[0]); }
break;
#line 539 "leasegrammer.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
