/***************************************************************************
                          mylistviewitem.cpp  -  description
                             -------------------
    copyright            : (C) 2002 by Willy De la Court
    email                : willy.delacourt@pandora.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2 as     *
 *   published by the Free Software Foundation                             *
 *                                                                         *
 ***************************************************************************/

#include <qpixmap.h>
#include <qpainter.h>
#include "mlistviewitem.h"
#include "configwidget.h"

MListViewItem::MListViewItem(QListView *parent, QString text, ConfigWidget *action)
		:KListViewItem(parent, text)
{
	syntax_error = false;
	actionWidget = action;
}

MListViewItem::MListViewItem(QListView *parent, QString text, QString text2, ConfigWidget *action)
		:KListViewItem(parent, text, text2)
{
	syntax_error = false;
	actionWidget = action;
}

MListViewItem::MListViewItem(QListView *parent, QString text, QString text2, QString text3, ConfigWidget *action)
		:KListViewItem(parent, text, text2, text3)
{
	syntax_error = false;
	actionWidget = action;
}

MListViewItem::MListViewItem(QListViewItem *parent, QString text, ConfigWidget *action)
		:KListViewItem(parent, text)
{
	syntax_error = false;
	actionWidget = action;
}

MListViewItem::MListViewItem(QListViewItem *parent, QString text, QString text2, ConfigWidget *action)
		:KListViewItem(parent, text, text2)
{
	syntax_error = false;
	actionWidget = action;
}

MListViewItem::MListViewItem(QListView *parent, QListViewItem *after, QString text, QString text2, bool syntax)
		:KListViewItem(parent, after, text, text2)
{
	syntax_error = syntax;
	actionWidget = 0;
}

MListViewItem::~MListViewItem()
{
	if( actionWidget )
		delete actionWidget;
}

// stupid because isalternate is not virtual i need to copy the whole code
void MListViewItem::paintCell( QPainter *p, const QColorGroup &cg, int column, int width, int alignment )
{
	QColorGroup _cg( cg );

	if ( syntax_error )
	{
		_cg.setColor( QColorGroup::Base, Qt::red );
		_cg.setColor( QColorGroup::Text, Qt::black );
	}
	else
	{
		const QPixmap *pm = listView()->viewport()->backgroundPixmap();
		if (pm && !pm->isNull())
		{
				_cg.setBrush(QColorGroup::Base, QBrush(backgroundColor(), *pm));
				QPoint o = p->brushOrigin();
				p->setBrushOrigin( o.x()-listView()->contentsX(), o.y()-listView()->contentsY() );
		}
		else if (isAlternate())
			if (listView()->viewport()->backgroundMode()==Qt::TransparentMode)
					_cg.setColor(QColorGroup::Background, static_cast< KListView* >(listView())->alternateBackground());
			else
				_cg.setColor(QColorGroup::Base, static_cast< KListView* >(listView())->alternateBackground());
	}
	QListViewItem::paintCell(p, _cg, column, width, alignment);
}


